/** @file dsapu_null.cpp
 *  @author Mic
 *  @date 2007
 *
 *  @brief Null audio processing unit emulation for Dualis.
 */

#include "dsapu_null.h"
#include "zombie.h"


#define APU_VERSION 24


zombie_callback zombie;
char			apuName[] = "DS APU NULL";
HINSTANCE		hInst;


bool __stdcall DllMain(HINSTANCE hDLL,DWORD reason,LPVOID unused)
{
	if (reason==DLL_PROCESS_ATTACH)
		hInst = hDLL;

	return true;
}



///////////////////////////////////////////////////////////////////////////////////////



/**
 *  @brief Initializes APU emulation.
 *
 *  @param commlink Callback to the main message hub
 *
 *  @return true on success, otherwise false
 */
bool __stdcall apu_init(zombie_callback commlink) {
	zombie = commlink;

	return true;

}



/**
 *  @brief Resets APU emulation
 *
 *  @return true on success, otherwise false
 */
bool __stdcall apu_reset() {
	return true;
}


/**
 *  @brief Shuts down APU emulation.
 *
 *  @return
 */
void __stdcall apu_close() {
}



int __stdcall apu_config(HWND hwnd) {
	return 0; 
}




/**
 *  @brief Mixes audio channels and writes the samples to a buffer.
 *
 *  @return
 */
void apu_mix() {
}


void __stdcall apu_write(unsigned int offset, unsigned int data) {
}

void __stdcall apu_update() {
}



/**
 *  @brief Returns information about the plugin
 */
int __stdcall apu_get(int what) {
	switch (what) {
		case APU_WRITE_CALLBACK:
			return (int)apu_write;
		case APU_MIX_CALLBACK:
			return (int)apu_mix;
		case PLUGIN_NAME:
			return (int)&apuName;
		case PLUGIN_VERSION:
			return APU_VERSION;
		case LAST_ERROR:
			return (int)0; //lpszError;
		default:
			break;
	}
	return 0;
}


void __stdcall apu_set(int what, void* param1, void* param2) {
}

