#include "arm7_write.h"

void WRHDECL arm7_write_byte_gen(unsigned int address,int word) {
	unsigned int page = address>>24,pagen=address>>20,offset=address&0x0FFFFF;

	if (arm7_pageTable[pagen])
		if (arm7_pageLength[page]>offset)
			*(unsigned char*)(arm7_pageTable[pagen] + offset) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_dtcm(unsigned int address,int word) {
}

void WRHDECL arm7_write_byte_itcm(unsigned int address,int word) {
}


void WRHDECL arm7_write_byte_ptok(unsigned int address,int word) {
	*(arm7_pageTable[address>>20] + (address&0xFFFFF)) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_wram(unsigned int address,int word) {
	*(arm7_pageTable[address>>20] + (address&arm7_pageMask[address>>20])) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_ewram(unsigned int address,int word) {
	*(unsigned char*)(EIWRAM + ((address)&0xFFFF)) = (unsigned char)word;
}

void WRHDECL arm7_write_byte_sram(unsigned int address,int word) {
	*(arm7_pageTable[0xA] + (address&0xFFFF)) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_plt(unsigned int address,int word) {
	*(PLT_VRAM + (address&0xFFF)) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_oam(unsigned int address,int word) {
	*(OAM + (address&0x7FF)) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_io(unsigned int address,int word) {
	unsigned int pagen=address>>20,offset=address&0x0FFFFF;

//	if (arm9_pageTable[pagen])
//		if (pageLength[4]>offset)
			*(arm7_pageTable[pagen] + offset) = (unsigned char)word;


	if ((offset>=0x400)&&(offset<=0x504)) {
		apu_write(address,word);
		return;
	}

	switch (offset)	{
		case IME:
			*(int*)(arm7_pageTable[0x40] + IME) &= 1;
			break;
		case IE:
			//wsprintf(buffer,"[%08X] = %02X, at %X\n",address,word&0xFF,arm7_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			break;

		case IF_:
			irqFlags7 &= ((word^0xFFFF)&0xFF)|0xFFFFFF00;
			*(unsigned short int*)(arm7_pageTable[pagen] + offset) = irqFlags7;
			break;
		/*case TM0CNT:
			timer_setup(0);
			break;
		case TM1CNT:
			timer_setup(1);
			break;
		case TM2CNT:
			timer_setup(2);
			break;
		case TM3CNT:
			timer_setup(3);
			break;*/

		case 0x180:
			//wsprintf(buffer,"(9) [%08X] = %04X, at %X\n",address,word&0xFFFF,arm9_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			/**(unsigned short*)(arm7_pageTable[pagen] + 0x180) &= 0xFFF0;
			*(unsigned char*)(arm7_pageTable[pagen] + 0x180) |= (word>>8)&0xF;*/
			*(arm7_pageTable[pagen] + 0x180) &= 0xF0;
			*(arm7_pageTable[pagen] + 0x180) |= ipcSync7;
			//ipcSync7 = (word>>8)&0xF;
			break;
		
		case 0x184:
			//wsprintf(buffer,"(9) [%08X] = %04X, at %X\n",address,word&0xFFFF,arm9_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			//arm9FifoCnt &= ((word&0x4000)^0x4000);
			//*(unsigned short int*)(arm9_pageTable[0x40] + 0x184) = arm9FifoCnt;
			break;
		case 0x188:
			ipc_fifo_send(0,word&0xFF);
			break;

		case 0x1C2:
			//wsprintf(buffer,"(7) [%08X] = %04X, at %X\n",address,word&0xFFFF,arm7_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			break;

	}
}


void WRHDECL arm7_write_byte_wifi(unsigned int address,int word) {
	if ((address&0xFFFFF)<0x10000)
		*(unsigned char*)(arm7_pageTable[0x48] + (address&0xFFFF)) = (unsigned char)word;
}


void WRHDECL arm7_write_byte_na(unsigned int address,int word) {
}


void WRHDECL arm7_write_byte_vram(unsigned int address,int word)
{
	int chunk = (address>>14)&0x3FF;

	if (vramChunk[chunk]) {
		*(unsigned char*)(vramChunk[chunk] + (address&0x3FFF)) = (unsigned char)word;
	}
}

void WRHDECL arm7_write_byte_lcdc(unsigned int address,int word) {
	int chunk;
	address &= 0xFFFFF; if (address>0xA3FFF) address-=0xA3FFF; 
	chunk = ((address>>14)|0x200)&0x3FF;
	if (vramChunk[chunk]) {
		*(unsigned char*)(vramChunk[chunk] + (address&0x3FFF)) = (unsigned char)word;
	}
}


//////////////////////////////////////////////////////////////////////////////////////////


void WRHDECL arm7_write_word_gen(unsigned int address,int word) {
	unsigned int page = address>>24,pagen=address>>20,offset=address&0x0FFFFF;

	if (arm7_pageTable[pagen])
		if (arm7_pageLength[page]>offset)
			*(unsigned short int*)(arm7_pageTable[pagen] + offset) = (unsigned short int)word;
}


void WRHDECL arm7_write_word_dtcm(unsigned int address,int word) {
}


void WRHDECL arm7_write_word_itcm(unsigned int address,int word) {
}


void WRHDECL arm7_write_word_ptok(unsigned int address,int word) {
	*(unsigned short int*)(arm7_pageTable[address>>20] + (address&0xFFFFF)) = (unsigned short int)word;
}


void WRHDECL arm7_write_word_wram(unsigned int address,int word) {
	//	wsprintf(buffer,"[%08X] = %04X, at %X\n",address,word&0xFFFF,arm7_regs[15]);
	//	WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);

	*(unsigned short int*)(arm7_pageTable[address>>20] + (address&arm7_pageMask[address>>20])) = (unsigned short int)word;
}


void WRHDECL arm7_write_word_ewram(unsigned int address,int word) {
	/*if ((address >= 0x3807a10)&&(address <= 0x3807a14)) {
		wsprintf(buffer,"[%08X] = %08X, PC=%08X, WRAMCNT=%d\n",address,word,arm7_regs[15],IOREGS[0x247]);
		WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
	}*/

	*(unsigned short int*)(EIWRAM + ((address)&0xFFFF)) = (unsigned short int)word;
}


void WRHDECL arm7_write_word_plt(unsigned int address,int word) {
	//*(unsigned short int*)(PLT_VRAM + (address&0xFFF)) = (unsigned short int)word;
}


void WRHDECL arm7_write_word_oam(unsigned int address,int word) {
	//*(unsigned short int*)(OAM + (address&0x7FF)) = (unsigned short int)word;
}


bool tsclowbits = true;
unsigned short tsccnt,tscdata,spicnt;

void WRHDECL arm7_write_word_io(unsigned int address,int word) {
	unsigned int pagen=address>>20,offset=address&0x0FFFFF;
	int tx,ty;

	*(unsigned short int*)(arm7_pageTable[pagen] + offset) = (unsigned short int)word;

	if ((offset>=0x400)&&(offset<=0x504)) {
		apu_write(address,word);
		return;
	}

	switch (offset)
	{
		case REG_DIVCNT:
			//wsprintf(buffer,"[%08X] = %04X, at %X\n",address,word,arm7_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			cp_div(word&3);
			break;
		case REG_NUMER_L:		
		case REG_NUMER_L+2:		
		case REG_DENOM_L:		
		case REG_DENOM_L+2:		
			cp_div(-1);
			break;

		case REG_SQRTCNT:
			cp_sqrt(word&3);
			break;
			
		case 0xBA:
			dma_setup(1,0,false);
			break;
		case 0xC6:
			dma_setup(1,1,false);
			break;
		case 0xD2:
			dma_setup(1,2,false);
			break;
		case 0xDE:
			dma_setup(1,3,false);
			break;

		case IME:
			*(int*)(arm7_pageTable[0x40] + IME) &= 1;
			//wsprintf(buffer,"(7) [%08X] = %04X, at %X\n",address,word&0xFFFF,arm7_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			break;
		
		case IF_:
			irqFlags7 &= (word^0xFFFF)|0xFFFF0000;
			*(unsigned int*)(arm7_pageTable[pagen] + IF_) = irqFlags7;
			break;
		case IF_+2:
			irqFlags7 &= ((word^0xFFFF)<<16)|0xFFFF;
			*(unsigned int*)(arm7_pageTable[pagen] + IF_) = irqFlags7;
			break;

		case TM0CNT:
			timer_setup(1,0);
			break;
		case TM1CNT:
			timer_setup(1,1);
			break;
		case TM2CNT:
			timer_setup(1,2);
			break;
		case TM3CNT:
			timer_setup(1,3);
			break;

		case 0x1C0:
			break;
		case 0x1C2:
			if (word!=0) tsccnt=word;
			spicnt = *(unsigned short int*)(arm7_pageTable[0x40] + 0x1C0); 
			if ((spicnt&0x300)==0x200) {
				tx = touch->x << 4;
				ty = (touch->y-16) << 4;
				//tx = ((touch->x*3536)>>8) + 0x100;
				//ty = (((touch->y-16)*4928)>>8) + 0xB0;
				switch (tsccnt&0x70) {
					case 0x00 :
						tscdata = 0;
                        break;
                    case 0x10:
						//wsprintf(buffer,"x,y = %d,%d. exkey=%X\n",tx,ty,extkeys);
						//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
						if (spicnt&0x800) {
							if(tsclowbits) {
								tscdata = ((ty<<3)&0x7FF);
                                tsclowbits = false;
                                break;
                            }
                            tscdata = ty>>5;
                            tsclowbits = true;
                            break;
                        }
                        tscdata = (ty<<3)&0x7FF;
                        tsclowbits = true;
                        break;
                    case 0x20 :
                        tscdata = 0;
                        break;
                    case 0x30 :
                        tscdata = 0;
                        break;
                    case 0x40 :
                        tscdata = 0;
                        break;
                    case 0x50 :
						if (spicnt&0x800) {
							if (tsclowbits) {
								tscdata = (tx<<3)&0x7FF;
                                tsclowbits = false;
                                break;
                            }
                            tscdata = (tx>>5);
                            tsclowbits = true;
                            break;
                        }
                        tscdata = (tx<<3)&0x7FF;
                        tsclowbits = true;
                        break;
                    case 0x60 :
						tscdata = 0;
                        break;
                    case 0x70 :
                        tscdata = 0;
                        break;
				}
            }
			*(unsigned short int*)(arm7_pageTable[pagen] + offset) = tscdata;
			break;

		case 0x180:
			// Update bits on remote side
			*(unsigned short int*)(arm9_pageTable[pagen] + 0x180) &= 0xFFF0;
			*(unsigned short int*)(arm9_pageTable[pagen] + 0x180) |= (word>>8)&0xF;
			// Local side
			*(arm7_pageTable[pagen] + 0x180) &= 0xF0;
			*(arm7_pageTable[pagen] + 0x180) |= ipcSync7;
			ipcSync7 &= ~0x6000;
			ipcSync7 |= (word&0x6000);
			ipcSync = (word>>8)&0xF;
			if ((word&0x2000)&&(ipcSync&0x4000)) {
				IOREGS[IF_+2] |= 1;
				irqFlags |= 0x10000;
				cpu_irq(0x18);
			}
			break;
		
		case 0x184:
			/*arm7FifoCnt &= ~0x8404;
			arm7FifoCnt |= (word&0x8404);
			arm7FifoCnt &= (~(word&0x4000));
			*(unsigned short int*)(arm7_pageTable[0x40] + 0x184) = arm7FifoCnt;
			break;*/
			arm7FifoCnt &= ~0x8404;
			arm7FifoCnt |= (word&0x8404);
			arm7FifoCnt &= (~(word&0x4000));
			if (word&8) {
				arm7FifoCnt |= 1;
				arm9FifoCnt |= 0x100;
				*(unsigned short int*)(arm9_pageTable[0x40] + 0x184) = arm9FifoCnt;
				if (arm7FifoCnt & 4) {
					IOREGS_ARM7[IF_+2] |= 4;
					irqFlags7 |= 0x40000;
					arm7_irq(0x18);
				}
			}
			*(unsigned short int*)(arm7_pageTable[0x40] + 0x184) = arm7FifoCnt;
			break;

		case 0x188:
			ipc_fifo_send(1,word&0xFFFF);
			break;

		case 0x240:
			//IOREGS[0x247] = (word>>8)&0xFF;
			//remap_wram(1);
			break;
		case 0x241:
			//IOREGS[0x247] = word&0xFF;
			//zombie(TELL,MMU_PAGE_TABLE,1,(void*)&arm7_pageTable[0]);
			//remap_wram(1);
			break;

	}
}


void WRHDECL arm7_write_word_wifi(unsigned int address,int word) {
	if ((address&0xFFFFF)<0x10000)
		*(unsigned short*)(arm7_pageTable[0x48] + (address&0xFFFF)) = (unsigned short)word;
}


void WRHDECL arm7_write_word_na(unsigned int address,int word) {
}


void WRHDECL arm7_write_word_vram(unsigned int address,int word) {
	int chunk = (address>>14)&0x3FF;
	//dummy = address;

	//if (chunk==0x3)
	/*if ((address >= 0x600F800) && (address < 0x600FA00))
	{
		wsprintf(buffer,"[%08X] = %04X, chunk=%d, [chunk]=%X, %X\n",address,word&0xFFFF,
			chunk,vramChunk[chunk],vramChunk[chunk] + (address&0x3FFF));
		WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
	}*/

	if (vramChunk[chunk]) {
		*(unsigned short int*)(vramChunk[chunk] + (address&0x3FFF)) = (unsigned short int)word;
	}
}

void WRHDECL arm7_write_word_lcdc(unsigned int address,int word) {
	int chunk;
	address &= 0xFFFFF; if (address>0xA3FFF) address-=0xA3FFF; //if (address>0x9FFFF) address-=0x9FFFF;
	chunk = ((address>>14)|0x200)&0x3FF;
	/*if (vramChunk[chunk]) {
		*(unsigned short int*)(vramChunk[chunk] + (address&0x3FFF)) = (unsigned short int)word;
	}*/
}



/////////////////////////////////////////////////////////////////////////////////////////


void WRWDECL arm7_write_dword_gen(unsigned int address,int word) {
	unsigned int page = address>>24,pagen=address>>20,offset=address&0x0FFFFC;
	//dummy = address;

	if (arm7_pageTable[pagen])
		if (arm7_pageLength[page]>offset)
			*(int*)(arm7_pageTable[pagen] + offset) = word;
}


void WRWDECL arm7_write_dword_dtcm(unsigned int address,int word) {
}

void WRHDECL arm7_write_dword_itcm(unsigned int address,int word) {
}

void WRWDECL arm7_write_dword_ptok(unsigned int address,int word) {
	*(int*)(arm7_pageTable[address>>20] + (address&0xFFFFC)) = word;
}


void WRWDECL arm7_write_dword_wram(unsigned int address,int word) {
	//	wsprintf(buffer,"[%08X] = %08X, at %X\n",address,word,arm7_regs[15]);
	//	WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
	*(int*)(arm7_pageTable[address>>20] + (address&arm7_pageMask[address>>20])) = word;
}


void WRWDECL arm7_write_dword_ewram(unsigned int address,int word) {
	/*if ((address == 0x38096ec)||(address==0x380972c)||(address==0x380ff7c)) {
		wsprintf(buffer,"[%08X] = %08X, PC=%08X, CPSR=%08X, WRAMCNT=%d\n",address,word,arm7_regs[15],arm7_regs[16],IOREGS[0x247]);
		WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
	}*/

	*(int*)(EIWRAM + ((address)&0xFFFC)) = word;
}


void WRWDECL arm7_write_dword_plt(unsigned int address,int word) {
	//*(int*)(PLT_VRAM + (address&0xFFC)) = word;
}


void WRWDECL arm7_write_dword_oam(unsigned int address,int word) {
	//*(int*)(OAM + (address&0x7FC)) = word;
}


void WRWDECL arm7_write_dword_io(unsigned int address,int word) {
	unsigned int pagen=address>>20,offset=address&0x0FFFFC;

	*(int*)(arm7_pageTable[pagen] + offset) = word;

	/*if ((offset>=0x400)&&(offset<=0x600)) {
		gpu_set(GPU_3D_COMMAND,offset,word);
		return;
	}*/

	if ((offset>=0x400)&&(offset<=0x504)) {
		apu_write(address,word);
		return;
	}

	if ((address >= 0x40001A4) && (address <= 0x40001B0)) {
		wsprintf(buffer,"[%08X] = %08X, at %X\n",address,word,arm7_regs[15]);
		WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
	}

	switch (offset)
	{
		case REG_DIVCNT:
			//wsprintf(buffer,"[%08X] = %08X, at %X\n",address,word,arm7_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			cp_div(word&3);
			break;
		case REG_NUMER_L:
		case REG_DENOM_L:
			cp_div(-1);
			break;
		case REG_SQRTPARM:
			cp_sqrt(-1);
			break;

		case TM0D:
		case TM0CNT:
			timer_setup(1,0);
			break;
		case TM1D:
		case TM1CNT:
			timer_setup(1,1);
			break;
		case TM2D:
		case TM2CNT:
			timer_setup(1,2);
			break;
		case TM3D:
		case TM3CNT:
			timer_setup(1,13);
			break;

		case 0x180:
			*(unsigned int*)(arm9_pageTable[pagen] + 0x180) &= 0xFFFFFFF0;
			*(unsigned int*)(arm9_pageTable[pagen] + 0x180) |= (word>>8)&0xF;
			*(arm7_pageTable[pagen] + 0x180) &= 0xF0;
			*(arm7_pageTable[pagen] + 0x180) |= ipcSync7;
			ipcSync = (word>>8)&0xF;
			break;

		case 0x184:
			arm7FifoCnt &= ~0x8404;
			arm7FifoCnt |= (word&0x8404);
			arm7FifoCnt &= (~(word&0x4000));
			if (word&8) {
				arm7FifoCnt |= 1;
				arm9FifoCnt |= 0x100;
				*(unsigned short int*)(arm9_pageTable[0x40] + 0x184) = arm9FifoCnt;
				if (arm7FifoCnt & 4) {
					IOREGS_ARM7[IF_+2] |= 4;
					irqFlags7 |= 0x40000;
					arm7_irq(0x18);
				}
			}
			*(unsigned short int*)(arm7_pageTable[0x40] + 0x184) = arm7FifoCnt;
			break;
			
		case 0x188:
			ipc_fifo_send(1,word);
			break;

		case IME:
			*(int*)(arm7_pageTable[0x40] + IME) &= 1;
			//wsprintf(buffer,"(7) [%08X] = %04X, at %X\n",address,word&0xFFFF,arm7_regs[15]);
			//WriteConsole(hout,buffer,lstrlen(buffer),(unsigned long*)&dummy,NULL);
			break;

		case IF_-2:
			//irqFlags7 &= ((word>>16)^0xFFFF);
			//*(unsigned short int*)(arm7_pageTable[pagen] + IF_) = irqFlags7;
			break;
		case IF_:
			irqFlags7 &= (word^0xFFFFFFFF);
			*(unsigned int*)(arm7_pageTable[pagen] + IF_) = irqFlags7;
			break;

		case 0xB8:
			dma_setup(1,0,false);
			break;
		case 0xBA:
			dma_setup(1,0,false);
			break;
		case 0xC4:
			dma_setup(1,1,false);
			break;
		case 0xC6:
			dma_setup(1,1,false);
			break;
		case 0xD0:
			dma_setup(1,2,false);
			break;
		case 0xD2:
			dma_setup(1,2,false);
			break;
		case 0xDC:
			dma_setup(1,3,false);
			break;
		case 0xDE:
			dma_setup(1,3,false);
			break;

		case 0x23D:
		case 0x23E:
		case 0x23F:
		case 0x240:
		case 0x241:
		/*case 0x242:
		case 0x243:
		case 0x244:
		case 0x245:
		case 0x246:
		case 0x247:
		case 0x248:
		case 0x249:*/
			for (int i=offset; i<offset+4; i++)	{
				/*if (i>0x249) break;
				if ((offset>=0x240)&&(offset != 0x247))
					remap_vram(i - ((offset>0x246)?0x241:0x240),word&0xFF);*/
				//if (offset==0x241)
				//	remap_wram(1);
					//zombie(TELL,MMU_PAGE_TABLE,1,(void*)&arm7_pageTable[0]);
				//	IOREGS[0x247] = word&0xFF;
				word >>= 8;
			}
			break;
	}
}


void WRWDECL arm7_write_dword_wifi(unsigned int address,int word) {
	if ((address&0xFFFFF)<0x10000)
		*(int*)(arm7_pageTable[0x48] + (address&0xFFFF)) = word;
}


void WRWDECL arm7_write_dword_na(unsigned int address,int word) {
}


void WRWDECL arm7_write_dword_vram(unsigned int address,int word) {
	int chunk = (address>>14)&0x3FF;

	if (vramChunk[chunk]) {
		*(int*)(vramChunk[chunk] + (address&0x3FFC)) = word;
	}
}

void WRWDECL arm7_write_dword_lcdc(unsigned int address,int word) {
	int chunk;
	address &= 0xFFFFF; if (address>0xA3FFF) address-=0xA3FFF;
	chunk = ((address>>14)|0x200)&0x3FF;

	/*if (vramChunk[chunk]) {
		*(int*)(vramChunk[chunk] + (address&0x3FFC)) = word;
	}*/
}


