/** @file cflash.h
 *  @author Mic
 *	@date 2006
 *  @brief CompactFlash/FAT emulation declarations for Dualis.
 */   
#ifndef __CFLASH_H__
#define __CFLASH_H__

#include "stdafx.h"
#include "fat.h"

#define CMD_READ  0x20
#define CMD_WRITE 0x30


/** 
 *  @brief Struct containing extra information about directory entries.
 */
typedef struct FILE_INFO {
	int level,		/**< The dirent's level in the hierarchy */
		parent,		/**< The level of the dirent's parent directory */
		filesInDir; /**< The number of file in the directory */
} FILE_INFO;


bool cflash_init();

unsigned int cflash_read(unsigned int address);

void cflash_write(unsigned int address,unsigned int data);

void cflash_close();



#endif
